"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  pluginVue2: () => pluginVue2
});
module.exports = __toCommonJS(src_exports);
var import_vue_loader = require("vue-loader");

// src/VueLoader15PitchFixPlugin.ts
var VueLoader15PitchFixPlugin = class {
  constructor() {
    __publicField(this, "name", "VueLoader15PitchFixPlugin");
  }
  apply(compiler) {
    const { NormalModule } = compiler.webpack;
    compiler.hooks.compilation.tap(this.name, (compilation) => {
      const isExpCssOn = compilation.compiler.options?.experiments?.css;
      if (!isExpCssOn)
        return;
      NormalModule.getCompilationHooks(compilation).loader.tap(
        this.name,
        (loaderContext) => {
          if (
            // the related issue only happens for <style>
            /[?&]type=style/.test(loaderContext.resourceQuery) && // the fix should be applied before `pitch` phase completed.
            // once `pitch` phase completed, vue-loader will remove its pitcher loader.
            /[\\/]vue-loader[\\/]lib[\\/]loaders[\\/]pitcher/.test(
              loaderContext.loaders?.[0]?.path || ""
            )
          ) {
            const seen = /* @__PURE__ */ new Set();
            const loaders = [];
            for (const loader of loaderContext.loaders || []) {
              const identifier = typeof loader === "string" ? loader : loader.path + loader.query;
              if (!seen.has(identifier)) {
                seen.add(identifier);
                loaders.push(loader);
              }
            }
            loaderContext.loaders = loaders;
          }
        }
      );
    });
  }
};

// src/splitChunks.ts
var import_shared = require("@rsbuild/shared");
var applySplitChunksRule = (api, options = {
  vue: true,
  router: true
}) => {
  api.modifyBundlerChain((chain) => {
    const config = api.getNormalizedConfig();
    if (config.performance.chunkSplit.strategy !== "split-by-experience") {
      return;
    }
    const currentConfig = chain.optimization.splitChunks.values();
    if (!(0, import_shared.isPlainObject)(currentConfig)) {
      return;
    }
    const extraGroups = {};
    if (options.vue) {
      extraGroups.vue = ["vue", "vue-loader"];
    }
    if (options.router) {
      extraGroups.router = ["vue-router"];
    }
    if (!Object.keys(extraGroups).length) {
      return;
    }
    chain.optimization.splitChunks({
      ...currentConfig,
      // @ts-expect-error Rspack and Webpack uses different cacheGroups type
      cacheGroups: {
        ...currentConfig.cacheGroups,
        ...(0, import_shared.createCacheGroups)(extraGroups)
      }
    });
  });
};

// src/index.ts
function pluginVue2(options = {}) {
  return {
    name: "rsbuild:vue2",
    setup(api) {
      const VUE_REGEXP = /\.vue$/;
      const CSS_MODULES_REGEX = /\.modules?\.\w+$/i;
      api.modifyRsbuildConfig((config) => {
        var _a;
        config.output || (config.output = {});
        (_a = config.output).cssModules || (_a.cssModules = {});
        if (config.output.cssModules.auto === true) {
          config.output.cssModules.auto = (path, query) => {
            if (VUE_REGEXP.test(path)) {
              return query.includes("type=style") && query.includes("module=true");
            }
            return CSS_MODULES_REGEX.test(path);
          };
        }
        return config;
      });
      api.modifyBundlerChain((chain, { CHAIN_ID }) => {
        chain.resolve.extensions.add(".vue");
        if (!chain.resolve.alias.get("vue$")) {
          chain.resolve.alias.set("vue$", "vue/dist/vue.runtime.esm.js");
        }
        const userLoaderOptions = options.vueLoaderOptions ?? {};
        const compilerOptions = {
          preserveWhitespace: false,
          ...userLoaderOptions.compilerOptions
        };
        const vueLoaderOptions = {
          experimentalInlineMatchResource: true,
          ...userLoaderOptions,
          compilerOptions
        };
        chain.module.rule(CHAIN_ID.RULE.VUE).test(VUE_REGEXP).use(CHAIN_ID.USE.VUE).loader(require.resolve("vue-loader")).options(vueLoaderOptions);
        chain.plugin(CHAIN_ID.PLUGIN.VUE_LOADER_PLUGIN).use(import_vue_loader.VueLoaderPlugin);
        chain.plugin(CHAIN_ID.PLUGIN.VUE_LOADER_15_PITCH_FIX_PLUGIN).use(VueLoader15PitchFixPlugin);
      });
      applySplitChunksRule(api, options.splitChunks);
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  pluginVue2
});
